// MiyaCalibView.h : CMiyaCalibView NX̃C^[tFCX
//


#pragma once


class CMiyaCalibView : public CView
{
protected: // VÂݍ쐬܂B
	CMiyaCalibView();
	DECLARE_DYNCREATE(CMiyaCalibView)

// 
public:
	CMiyaCalibDoc* GetDocument() const;

// 
public:

// I[o[Ch
public:
	virtual void OnDraw(CDC* pDC);  // ̃r[`悷邽߂ɃI[o[Ch܂B
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
protected:

// 
public:
	virtual ~CMiyaCalibView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// ꂽAbZ[W蓖Ċ֐
protected:
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	double* point3d;
	int* point3dproj;
	double PI;
	void CreateImages(void);
	unsigned char* screendata;
	int SIZEX;
	int SIZEY;
	bool* processdone;
	int PROCESSMAX;
	int MIYA_INTRINSIC;
	int MIYA_IMAGE;
	int MIYA_GEOMETRY;
	int MIYA_2D;
	int MIYA_POS;
	int MIYA_3D;
	int MIYA_CALIB;
	int viewmode;
	void RenderImages(bool memorybuffer);
	// modelview[0]  modelview[4]  modelview[8]  modelview[12]
	// modelview[1]  modelview[5]  modelview[9]  modelview[13]
	// modelview[2]  modelview[6]  modelview[10] modelview[14]
	// modelview[3]  modelview[7]  modelview[11] modelview[15]
	double modelview[16];
	double extmatgl[16];
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	CPoint prevpoint;
	bool buttondown;
	double EPS;
	afx_msg void OnExec2d();
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	int CORRESMAX;
	int corres2dnum;
	int* corres2d;
	int corres3dnum;
	int* corres3d;
	afx_msg void OnExecPos();
	afx_msg void OnExec3d();
	afx_msg void OnExecCalib();
	void CalcIndex();
	void SynthesizeImages();
	afx_msg void OnExecOpen();
	void ReadIntrinsic(CString sFileName);
	void ReadImage(CString sFileName);
	unsigned char* imagedata;
	void ReadGeometry(CString sFileName);
	int point3dnum;
	CvMat* intrinsic_matrix;
	inline double NORM(double x, double y, double z) {return sqrt(x*x + y*y + z*z);}
	double centerx, centery, centerz, scale;
	afx_msg void OnExecTarget();
	int POINT3DMAX;
	double viewscale;
	afx_msg void OnExecSave();
	void WriteExtrinsic(CString sFileName);
	afx_msg void OnDebugTest1();
	afx_msg void OnDebugTest2();
};

#ifndef _DEBUG  // MiyaCalibView.cpp ̃fobO o[W
inline CMiyaCalibDoc* CMiyaCalibView::GetDocument() const
   { return reinterpret_cast<CMiyaCalibDoc*>(m_pDocument); }
#endif

